r2c <- function(what, code.only=FALSE) {
    if (is.character(what)) what <- parse(text=what)
    else what <- substitute(what)
    if (code.only) {
        .Call("c", what, "fn", PACKAGE="r2c")
    } else {
        f <- tempfile("r2c")
        bn <- basename(f)
        dn <- dirname(f)
        s <- .Call("c", what, bn, PACKAGE="r2c")
        writeLines(s, paste(f,".c",sep=''))
        cwd<-getwd()
        setwd(dn)
        system(paste("PKG_CPPFLAGS=-I",system.file("runtime",package="r2c")," ",R.home(),"/bin/R CMD SHLIB ",bn,".c >/dev/null",sep=''))
        setwd(cwd)
        if (!file.exists(paste(f,".so",sep=''))) {
            cat(s)
            stop("compilation failed")
        }
        dyn.load(paste(f,".so",sep=''))
        f <- .Call(paste("get_",bn,sep=''))
        attr(f, "argnames") <- attr(s, "argnames")
        attr(f, "code") <- s
        f
    }
}
